/**
 * Copyright (c) 2017-present, Evosphere.
 * All rights reserved.
 */

const FormData = require('./FormData');

Object.defineProperty(global, "FormData", {
  configurable: true,
  value: FormData,
});

jest.mock('NetInfo', () => {
  let listeners = [], status = true;

  return {
    isConnected: {
      fetch: () => {
        return new Promise((accept) => {
          accept(status);
        })
      },
      addEventListener: (event, handler) => {
        listeners.push(handler);
      },
      listeners,
      setStatus(nextStatus){
        status = nextStatus;
      }
    },
  }
});
