'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * Copyright (c) 2017-present, Evosphere.
                                                                                                                                                                                                                                                                   * All rights reserved.
                                                                                                                                                                                                                                                                   */

exports.default = ShaaraReactNativeTask;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _StoreManager = require('./services/StoreManager');

var _StoreManager2 = _interopRequireDefault(_StoreManager);

var _NetworkStatus = require('./services/NetworkStatus');

var _NetworkStatus2 = _interopRequireDefault(_NetworkStatus);

var _SecurityToken = require('./services/SecurityToken');

var _SecurityToken2 = _interopRequireDefault(_SecurityToken);

var _RequestSender = require('./services/requestSender/RequestSender');

var _RequestSender2 = _interopRequireDefault(_RequestSender);

var _faussaire = require('faussaire');

var _faussaire2 = _interopRequireDefault(_faussaire);

var _faussaireAdapter = require('./services/requestSender/adapter/faussaireAdapter');

var _faussaireAdapter2 = _interopRequireDefault(_faussaireAdapter);

var _fetchAdapter = require('./services/requestSender/adapter/fetchAdapter');

var _fetchAdapter2 = _interopRequireDefault(_fetchAdapter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ShaaraReactNativeTask() {
  return {
    getServices: function getServices(container, parameters, env) {
      var faussaire = null;
      var networkStatus = _NetworkStatus2.default.getInstance();
      var requestSenderImplementation = function () {
        if (env === "test") {
          faussaire = _faussaire2.default.create();
          return (0, _faussaireAdapter2.default)(faussaire);
        }

        // If there's an user-defined fetch function, we can use it
        if (parameters.fetch) {
          return (0, _fetchAdapter2.default)(parameters.fetch);
        }

        if (typeof fetch !== "function") {
          (0, _invariant2.default)(false, "fetch is not defined. Cannot initialize the request sender.");
        }

        return (0, _fetchAdapter2.default)(fetch);
      }();

      return _extends({
        "store": _StoreManager2.default.create(),
        "network.status": networkStatus,
        "security.token": _SecurityToken2.default.createFromContainer(container),
        "request.sender": _RequestSender2.default.create(requestSenderImplementation, networkStatus.isConnected.bind(networkStatus))
      }, faussaire !== null ? { "faussaire": faussaire } : {});
    },
    configureKernel: async function configureKernel(config, kernel) {
      if (typeof config.getStoreConfiguration === "function") {
        await kernel.get("store").init(config.getStoreConfiguration());
      }

      if (typeof config.getTokenImplementation === "function") {
        kernel.get("security.token").setImplementation(config.getTokenImplementation(kernel._services));
      }
    }
  };
}