'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _interpretResult = require('./interpretResult');

var _interpretResult2 = _interopRequireDefault(_interpretResult);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Result(result) {
  this.status = result.status;
  this.response = result.response;
  this.interpretation = (0, _interpretResult2.default)(result);
} /**
   * Copyright (c) 2017-present, Evosphere.
   * All rights reserved.
   */


Result.prototype.getInterpretation = function () {
  return this.interpretation;
};

Result.prototype.getStatus = function () {
  return this.status;
};

Result.prototype.getStatusCode = function () {
  return this.response.statusCode;
};

Result.prototype.getData = function () {
  return this.response.data;
};

Result.prototype.getHeaders = function () {
  return this.response.headers;
};

exports.default = Result;