"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = checkResultFormat;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HttpRequestException = function (_Error) {
  _inherits(HttpRequestException, _Error);

  function HttpRequestException(message) {
    _classCallCheck(this, HttpRequestException);

    var _this = _possibleConstructorReturn(this, (HttpRequestException.__proto__ || Object.getPrototypeOf(HttpRequestException)).call(this, message));

    _this.name = "HttpRequestException";
    return _this;
  }

  return HttpRequestException;
}(Error);

/**
 * Ensure the result is having the correct format
 * @param result
 */

/**
 * Copyright (c) 2017-present, Evosphere.
 * All rights reserved.
 */

function checkResultFormat(result) {
  if ((typeof result === "undefined" ? "undefined" : _typeof(result)) !== "object" || result === null) {
    throw new HttpRequestException("The result must be an object");
  }

  if (typeof result.status !== "string" || result.status === "done" && (_typeof(result.response) !== "object" || result.response === null)) {
    throw new HttpRequestException("The result object is invalid. If the status is set to \"done\", you must provide a response object.");
  }

  if (_typeof(result.response) !== "object" && result.response !== null) {
    if (typeof result.response.statusCode !== "number") {
      throw new HttpRequestException("The result must have a status code that is a number.");
    }
  }
};