/**
 * Copyright (c) 2017-present, Evosphere.
 * All rights reserved.
 */
import interpretResult from './interpretResult';

function Result(result){
  this.status = result.status;
  this.response = result.response;
  this.interpretation = interpretResult(result);
}

Result.prototype.getInterpretation = function(){
  return this.interpretation;
};

Result.prototype.getStatus = function(){
  return this.status;
};

Result.prototype.getStatusCode = function(){
  return this.response.statusCode;
};

Result.prototype.getData = function(){
  return this.response.data;
};

Result.prototype.getHeaders = function(){
  return this.response.headers;
};

export default Result;