// @flow
/**
 * Copyright (c) 2017-present, Evosphere.
 * All rights reserved.
 */

import type { RequestConfiguration } from '../definitionTypes';
import type { HttpRequestImplementation } from '../RequestSender';

/**
 * Create an adapter around faussaire
 * @param instance
 */
const createAdapter = (instance : Object) => () : HttpRequestImplementation => {
  return {
    sendRequest: (request : RequestConfiguration) => {
      return new Promise(resolve => resolve(instance.emit(request)));
    }
  }
};

export default createAdapter;